# 'Distress call.py' by Defiant
# erik@defiant.homedns.org

import App
import MissionLib
import Lib.LibEngineering
import Foundation
import string
import math
from Lib.Races import Races
import loadspacehelper

MODINFO = { "Author": "\"Defiant\" erik@defiant.homedns.org",
            "Download": "http://defiant.homedns.org/~erik/STBC/Distress/",
            "Version": "0.1",
            "License": "GPL",
            "Description": "Send out an distress call."
            }

dict_Timer = {}
dict_Notify = {}
ShipInd = 1
ET_ADD = None
ET_NOTIFY = None
pButton = None

def GetShipType(pShip):
	# thanks to mldaalder for the idea using -1 instead of 1
        return string.split(pShip.GetScript(), '.')[-1]


# Species of the Ship
def GetShipSpecies(pShip):
	ShipType = GetShipType(pShip)
        if not ShipType:
            return
        FdtnShip = Foundation.shipList[ShipType]
        if not FdtnShip:
            return
        RaceName = FdtnShip.GetRace().name
	
	return RaceName


def AddShip(pObject, pEvent):
	global dict_Timer

	pGame		= App.Game_GetCurrentGame()
	pPlayer		= pGame.GetPlayer()
	pSet		= pPlayer.GetContainingSet()
        pEpisode	= pGame.GetCurrentEpisode()
        pMission	= pEpisode.GetCurrentMission()
	pEnemies	= pMission.GetEnemyGroup()
	pFriendlies	= pMission.GetFriendlyGroup()
	shipType	= dict_Timer[str(pEvent)][0]
	shipName	= dict_Timer[str(pEvent)][1]
	Position	= dict_Timer[str(pEvent)][2]
	
	pShip = loadspacehelper.CreateShip(shipType, pSet, shipName, "", 1)
	pShip.UpdateNodeOnly()
	CreateAIPosition(pShip, pSet)
	g_pAIShip = App.ShipClass_GetObject(pSet, shipName)

	if (Position == "friendly"):
		pFriendlies.AddName(pShip.GetName())
		pShip.SetAI(Lib.LibEngineering.CreateFriendlyAI(pShip))
	elif (Position == "enemy"):
		pEnemies.AddName(pShip.GetName())
		pShip.SetAI(Lib.LibEngineering.CreateEnemyAI(pShip))


# Starts the Timer to add ships
def AddShipTimer(ShipRace, ToAdd):
	global dict_Timer, ShipInd, ET_ADD, ET_NOTIFY, dict_Notify

	NotifyTime = 0

	# ok, thats what we have todo here:
	# 1. Get our enemys and friendlys
	if not Races.has_key(ShipRace):
		print("Error: No race info for", ShipRace)
		return
	
        #FIXME: God Ships!
	# 2. Find out what todo:
	if (ToAdd == "friendly"):
		# Get a random shiptype:
		if (len(Races[ShipRace].GetShips()) == 0):
			print("Error: No Ships for Race", ShipRace)
			return
		RandTypeNum = App.g_kSystemWrapper.GetRandomNumber(len(Races[ShipRace].GetShips()))
		ShipType = Races[ShipRace].GetShips()[RandTypeNum]
		Position = "friendly"
		RealShipName = Races[ShipRace].GetRandomName()
		NotifyTime = 1
	elif (ToAdd == "friendlyRace"):
		# Get a random friendly ShipRace
		if (len(Races[ShipRace].GetFriendlys()) == 0):
			print("ERROR: No friendly Race for", ShipRace)
			return
		RandRaceNum = App.g_kSystemWrapper.GetRandomNumber(len(Races[ShipRace].GetFriendlys()))
		friendRace = Races[ShipRace].GetFriendlys()[RandRaceNum]
		if not Races.has_key(friendRace):
			print("Error: No race info for", friendRace)
			return
		if (len(Races[friendRace].GetShips()) == 0):
			print("Error: No Ships for Race", friendRace)
			return
		RandTypeNum = App.g_kSystemWrapper.GetRandomNumber(len(Races[friendRace].GetShips()))
		ShipType = Races[friendRace].GetShips()[RandTypeNum]
		Position = "friendly"
		RealShipName = Races[ShipRace].GetRandomName()
		NotifyTime = 1
	elif (ToAdd == "enemy"):
		# Get a random enemy ShipRace
		if (len(Races[ShipRace].GetEnemys()) == 0):
			print("ERROR: No enemy Race for", ShipRace)
			return
		RandRaceNum = App.g_kSystemWrapper.GetRandomNumber(len(Races[ShipRace].GetEnemys()))
		enemyRace = Races[ShipRace].GetEnemys()[RandRaceNum]
		if not Races.has_key(enemyRace):
			print("Error: No race info for", enemyRace)
			return
		if (len(Races[enemyRace].GetShips()) == 0):
			print("Error: No Ships for Race", enemyRace)
			return
		RandTypeNum = App.g_kSystemWrapper.GetRandomNumber(len(Races[enemyRace].GetShips()))
		ShipType = Races[enemysRace].GetShips()[RandTypeNum]
		Position = "enemy"
		RealShipName = Races[ShipRace].GetRandomName()
	elif (ToAdd == "ferengi"):
		ShipType = "Marauder"
		Position = "neutral"
		RealShipName = "Ferengi"
	else:
		print("Error: Nothing todo")
		return

	# Preload
        try:
        	loadspacehelper.PreloadShip(ShipType, 1)
        except:
                print("Error: Cannot preload", ShipType)
                return

	ShipName = RealShipName + "-" + str(ShipInd)
	ShipInd = ShipInd + 1
	
	# Create an event - it's a thing that will call this function
	pTimerEvent = App.TGEvent_Create()
	pTimerEvent.SetEventType(ET_ADD)
	pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

	# Add in 30 seconds up to 5 minutes
	RealAddTime = App.g_kSystemWrapper.GetRandomNumber(270) + 30
	AddTime = App.g_kUtopiaModule.GetGameTime() + RealAddTime
	
	# Create a timer - it's a thing that will wait for a given time,then do something
	pTimer = App.TGTimer_Create()
	pTimer.SetTimerStart(AddTime)
	pTimer.SetDelay(0)
	pTimer.SetDuration(0)
	pTimer.SetEvent(pTimerEvent)
	App.g_kTimerManager.AddTimer(pTimer)

	print("Hole: ", ShipType, ShipName, "as", Position, "in", RealAddTime)
	# or any other Idea how to get Informations together with a Timer?
	dict_Timer[str(pTimerEvent)] = ShipType, ShipName, Position

	# if we add a friendly, we also Notify the Player
	if (NotifyTime == 1):
		RealNotifyTime = RealAddTime / (App.g_kSystemWrapper.GetRandomNumber(4) + 2)
		NotifyTime = App.g_kUtopiaModule.GetGameTime() + RealNotifyTime
		
		pTimer2Event = App.TGEvent_Create()
		pTimer2Event.SetEventType(ET_NOTIFY)
		pTimer2Event.SetDestination(App.TopWindow_GetTopWindow())
		pTimer2 = App.TGTimer_Create()
		pTimer2.SetTimerStart(NotifyTime)
		pTimer2.SetDelay(0)
		pTimer2.SetDuration(0)
		pTimer2.SetEvent(pTimer2Event)
		App.g_kTimerManager.AddTimer(pTimer2)

		# variant the arrive time about +/-10 seconds
		varTime = math.pow(-1, App.g_kSystemWrapper.GetRandomNumber(3)) * App.g_kSystemWrapper.GetRandomNumber(10)
		approxTime = RealAddTime - RealNotifyTime + varTime
		dict_Notify[str(pTimer2Event)] = RealShipName, approxTime


def reacButton(pObject, pEvent):
        global pButton
        pButton.SetEnabled()


# Print Help arriving in...seconds
def NotifyHelp(pObject, pEvent):
	global dict_Notify
	shipName = dict_Notify[str(pEvent)][0]
	approxTime = dict_Notify[str(pEvent)][1]
	pDatabase = App.g_kLocalizationManager.Load("data/TGL/Distress call.tgl")

	pcETA = pDatabase.GetString("ETA").GetCString()
	pcString = pcETA % (shipName, str(approxTime))

        # from Multiplayer
        pSequence = App.TGSequence_Create()
        pSubtitleAction = App.SubtitleAction_CreateC(pcString)
        pSubtitleAction.SetDuration(5.0)
        pSequence.AddAction(pSubtitleAction)
        pSequence.Play()
	App.STMissionLog_GetMissionLog().AddLine(App.TGString(pcString))


def SendCall(pObject, pEvent):
        global pButton
        pGame           = App.Game_GetCurrentGame()
	pPlayer		= pGame.GetPlayer()
        pEpisode	= pGame.GetCurrentEpisode()
        pMission	= pEpisode.GetCurrentMission()	
	pEnemyGroup     = pMission.GetEnemyGroup()
	pSet		= pPlayer.GetContainingSet()
	lpEnemys        = pEnemyGroup.GetActiveObjectTupleInSet(pSet)
        pDatabase       = App.g_kLocalizationManager.Load("data/TGL/Distress call.tgl")
        pBridge         = App.g_kSetManager.GetSet("bridge")
        g_pKiska        = App.CharacterClass_GetObject(pBridge, "Helm")
	countEnemy	= 0
	ferengidone	= 0

	# Count enemy Ships in System.
	for pEnemy in lpEnemys:
		countEnemy = countEnemy + 1
	# GetRandomNumber() will crash if used with 0. Make sure it is at least 1:
	if countEnemy == 0:
		countEnemy = 1

	# FIXME: Stations!
	PlayerSpecies = GetShipSpecies(pPlayer)

	# Chances:
	# Get amount of Ships:
	ShipCount = App.g_kSystemWrapper.GetRandomNumber(countEnemy * (App.g_kSystemWrapper.GetRandomNumber(2) + 1))
	# if ShipCount == 0 -> no ships coming
	for i in range(ShipCount):
		Chance = App.g_kSystemWrapper.GetRandomNumber(100) + 1
		# 1. Help from Same Race = 60%
		# 2. Help from friendly Race = 40%
		# 3. More enemy coming = 20%
		# 4. Ferengi just watching the fight, wants to get your hulk: 5%
		if (Chance <= 60):
			AddShipTimer(PlayerSpecies, "friendly")
		if (Chance <= 20) or (Chance > 80):
			AddShipTimer(PlayerSpecies, "friendlyRace")
		if (Chance > 60) or (Chance <= 80):
			AddShipTimer(PlayerSpecies, "enemy")
		if (Chance % 10 == 0) and (ferengidone == 0):
			ferengidone = 1
			AddShipTimer(PlayerSpecies, "ferengi")

        # tell call
        pSequence = App.TGSequence_Create()
	pAction = App.CharacterAction_Create(g_pKiska, App.CharacterAction.AT_SAY_LINE, "Start call", None, 0, pDatabase)
        pSequence.AppendAction(pAction)
        pSequence.Play()
       
        # and finally the Timer to reactivate the Button.
	myEvent = Lib.LibEngineering.GetEngineeringNextEventType()
        MissionLib.CreateTimer(myEvent, __name__ + ".reacButton", App.g_kUtopiaModule.GetGameTime() + 300, 0, 0)
        pButton.SetDisabled()


# from addship helper
def CreateAIPosition(g_pAIShip, pSet):
	kLocation = App.TGPoint3()
	X = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0 + 50 # for testing!!!!!!!!!!!!!!!!!
	X = X * (App.g_kSystemWrapper.GetRandomNumber (50) + 1)
	Y = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
	Y = Y * (App.g_kSystemWrapper.GetRandomNumber (50) + 1)
	Z = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0 - 50
	Z = Z * (App.g_kSystemWrapper.GetRandomNumber (50) + 1)
	kLocation.SetXYZ(X, Y, Z)
	
	while ( pSet.IsLocationEmptyTG(kLocation, g_pAIShip.GetRadius()*2, 1) == 0):
		print("Correcting Position for AI Ship")
		X = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
		X = X * (App.g_kSystemWrapper.GetRandomNumber (50) + 1)
		Y = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
		Y = Y * (App.g_kSystemWrapper.GetRandomNumber (50) + 1)
		Z = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
		Z = Z * (App.g_kSystemWrapper.GetRandomNumber (50) + 1)
		kLocation.SetXYZ(X, Y, Z)
	
	g_pAIShip.SetTranslate(kLocation)
	g_pAIShip.UpdateNodeOnly()
	

def init():
	global ET_ADD, ET_NOTIFY, pButton
	pButton = Lib.LibEngineering.CreateMenuButton("Send distress call", "XO", __name__ + ".SendCall")

	# Set Timer
	ET_ADD = Lib.LibEngineering.GetEngineeringNextEventType()
	ET_NOTIFY = Lib.LibEngineering.GetEngineeringNextEventType()
	App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(ET_ADD, __name__ + ".AddShip")
	App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(ET_NOTIFY, __name__ + ".NotifyHelp")
